"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _xhrApi = _interopRequireDefault(require("./xhrApi"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var isFormData = function isFormData(payload) {
  if (typeof FormData !== "undefined" && payload) {
    return payload.constructor == new FormData().constructor;
  }
  return typeof payload == "function";
};
var Builder = function Builder(apiJson, options) {
  //Url and param builder..
  var apiOptions = function apiOptions() {
    var _method = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var requestUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    var parameters = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var queryParameters = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var isFormDataFound = isFormData(parameters);
    var userParamsClone = Object.assign({}, isFormDataFound ? queryParameters : parameters); // to address re-back call ajax parameters keeping..
    if (Object.keys(userParamsClone).length) {
      var propsToUrl = requestUrl.split('/'); // helps to some parameter to url...
      for (var i = 0, len = propsToUrl.length; i < len; i++) {
        var prop = propsToUrl[i];
        var paramKey = prop.replace(':', '');
        if (prop && prop.charAt(0) === ':' && userParamsClone.hasOwnProperty(paramKey)) {
          var value = userParamsClone[paramKey];
          requestUrl = requestUrl.replace('/' + prop, value ? '/' + value : '');
          requestUrl = requestUrl.replace(prop + '/', value ? value + '/' : '');
          delete userParamsClone[paramKey];
        }
      }
    }
    var userParams = isFormDataFound ? parameters : userParamsClone;
    queryParameters = isFormDataFound ? userParamsClone : queryParameters;
    var defaultParams = Object.assign({}, queryParameters, options.defaultParams(_method));
    var gobalParamsToUrl = '';
    var count = 0;
    for (var prop in defaultParams) {
      if (count > 0) {
        gobalParamsToUrl += "&".concat(prop, "=").concat(defaultParams[prop]);
        break;
      }
      gobalParamsToUrl += "".concat(prop, "=").concat(defaultParams[prop]);
      count = 1;
    }
    gobalParamsToUrl = gobalParamsToUrl ? '?' + gobalParamsToUrl : '';
    if (!isFormDataFound) {
      var length = userParams ? Object.keys(userParams).length : 0;
      userParams = length > 0 ? userParams : null;
    }
    return {
      url: options.prefixUrl(_method) + requestUrl + gobalParamsToUrl,
      param: userParams
    };
  };

  //url - bind arguments not from user..
  var httpConnection = function httpConnection(ajaxmethod) {
    return function (url) {
      var ajaxoptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var ajaxoption2 = arguments.length > 2 ? arguments[2] : undefined;
      var ajaxoption3 = arguments.length > 3 ? arguments[3] : undefined;
      var urlHeaders = typeof options.authHeaders === "function" ? options.authHeaders(ajaxmethod) : null;
      var customOptions = options.customOptions || {};
      if (typeof ajaxoptions === "function" || typeof ajaxoption2 === "function") {
        var _success = typeof ajaxoptions === "function" ? ajaxoptions : ajaxoption2;
        var _failure = typeof ajaxoptions === "function" ? ajaxoption2 : ajaxoption3;
        var _payload = typeof ajaxoptions === "function" ? null : ajaxoptions;
        var _successCallback = function _successCallback(response) {
          customOptions.hideLoader && customOptions.hideLoader(ajaxmethod);
          return _success ? _success(response) : response;
        };
        var _failureCallback = function _failureCallback(errResponse) {
          customOptions.hideLoader && customOptions.hideLoader(ajaxmethod);
          return _failure ? _failure(errResponse) : errResponse;
        };
        var _apioptions = apiOptions(ajaxmethod, url, _payload);
        customOptions.showLoader && customOptions.showLoader(ajaxmethod);
        var param = _apioptions.param;
        if (param && param.headers) {
          urlHeaders = Object.assign(urlHeaders || {}, param.headers);
          delete param.headers;
        }
        return (0, _xhrApi["default"])(_apioptions.url, urlHeaders)[ajaxmethod](_apioptions.param, progressReport).then(_successCallback, _failureCallback);
      }
      var _ajaxoptions$payload = ajaxoptions.payload,
        payload = _ajaxoptions$payload === void 0 ? {} : _ajaxoptions$payload,
        headers = ajaxoptions.headers,
        parameters = ajaxoptions.parameters,
        success = ajaxoptions.success,
        failure = ajaxoptions.failure,
        progressReport = ajaxoptions.progressReport;
      urlHeaders = urlHeaders ? Object.assign(urlHeaders, headers) : headers; // Override headers

      var successCallback = function successCallback(response) {
        customOptions.hideLoader && customOptions.hideLoader(ajaxmethod);
        return success ? success(response) : response;
      };
      var failureCallback = function failureCallback(errResponse) {
        customOptions.hideLoader && customOptions.hideLoader(ajaxmethod);
        return failure ? failure(errResponse) : errResponse;
      };
      var apioptions = apiOptions(ajaxmethod, url, payload, parameters);
      customOptions.showLoader && customOptions.showLoader(ajaxmethod);
      return (0, _xhrApi["default"])(apioptions.url, urlHeaders)[ajaxmethod](apioptions.param, progressReport).then(successCallback, failureCallback);
    };
  };

  //auto api functions creation...
  var userAPIS = {};
  for (var prop in apiJson) {
    var api = prop;
    var apivalue = apiJson[prop];
    var apiurl = apivalue.url;
    var apimethod = apivalue.method;

    //var apiFragments = api.split('/');
    var apiFragments = api.split('.');
    var lastObj = userAPIS;
    for (var j = 0; j < apiFragments.length; j++) {
      var apiFragment = apiFragments[j];
      if (apiFragment.indexOf(':') != -1) {
        continue; //Skipping this !api
      }
      if (apiFragment && typeof lastObj[apiFragment] === 'undefined') {
        lastObj[apiFragment] = httpConnection(apimethod).bind(null, apiurl);
      }
      if (apiFragment && typeof lastObj[apiFragment] !== 'undefined') {
        lastObj = lastObj[apiFragment];
      }
    }
  }
  return userAPIS;
};
var _default = exports["default"] = /*#__PURE__*/function () {
  function _default(prefixUrl, defaultParams, authHeaders, options) {
    _classCallCheck(this, _default);
    this.prefixUrl = prefixUrl;
    this.defaultParams = defaultParams;
    this.authHeaders = authHeaders;
    this.options = options;
  }
  _createClass(_default, [{
    key: "create",
    value: function create(javaApiList, name) {
      var defaultParams = this.defaultParams ? this.defaultParams.bind(null, name) : null;
      var prefixUrl = this.prefixUrl ? this.prefixUrl.bind(null, name) : '';
      var authHeaders = this.authHeaders ? this.authHeaders.bind(null, name) : null;
      var customOptions = this.options ? this.options : null;
      return Builder(javaApiList || {}, {
        defaultParams: defaultParams,
        prefixUrl: prefixUrl,
        authHeaders: authHeaders,
        customOptions: customOptions
      });
    }
  }]);
  return _default;
}();